// JuliaFractalDialog.cpp : implementation file
//

#include "stdafx.h"
#include "JuliaFractal.h"
#include "JuliaFractalDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CJuliaFractalDialog dialog


CJuliaFractalDialog::CJuliaFractalDialog(CWnd* pParent /*=NULL*/)
	: CDialog(CJuliaFractalDialog::IDD, pParent)
{
	m_nTrackbar1 = 0;
	m_nTrackbar2 = 0;
	m_nTrackbar3 = 0;
	m_nTrackbar4 = 0;
	m_nTrackbar5 = 0;
	m_nTrackbar6 = 0;
	m_nTrackbar7=0;
	m_nTrackbar8=0;
	m_nTrackbar9=0;
	m_nTrackbar10=0;

	//{{AFX_DATA_INIT(CJuliaFractalDialog)
	m_nRes = -1;
	m_fSpin1 = 0.0f;
	m_fSpin3 = 0.0f;
	m_fSpin2 = 0.0f;
	m_bArreglar = FALSE;
	m_nColores = -1;
	m_bCheckConst = FALSE;
	m_nConst = -1;
	m_nNoInfinito = -1;
	m_bCheckZoom = FALSE;
	//}}AFX_DATA_INIT


}


void CJuliaFractalDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CJuliaFractalDialog)
	DDX_Radio(pDX, IDC_Res, m_nRes);
	DDX_Text(pDX, IDC_BUDDY_SPIN1, m_fSpin1);
	DDX_Text(pDX, IDC_BUDDY_SPIN3, m_fSpin3);
	DDX_Text(pDX, IDC_BUDDY_SPIN2, m_fSpin2);
	DDX_Check(pDX, IDC_ARREGLARV, m_bArreglar);
	DDX_Radio(pDX, IDC_Colores, m_nColores);
	DDX_Check(pDX, IDC_CHECK_Const, m_bCheckConst);
	DDX_Radio(pDX, IDC_Const, m_nConst);
	DDX_Radio(pDX, IDC_NoInfinito, m_nNoInfinito);
	DDX_Check(pDX, IDC_CHECK_Zoom, m_bCheckZoom);
	//}}AFX_DATA_MAP

	if (pDX->m_bSaveAndValidate) {
		TRACE("actualizando miembros de datos de la barra de seguimiento\n");
		CSliderCtrl* pSlide1 =(CSliderCtrl*) GetDlgItem(IDC_TRACKBAR1);
		m_nTrackbar1 = pSlide1->GetPos();
		CSliderCtrl* pSlide2 =(CSliderCtrl*) GetDlgItem(IDC_TRACKBAR2);
		m_nTrackbar2 = pSlide2->GetPos();
		CSliderCtrl* pSlide3 =(CSliderCtrl*) GetDlgItem(IDC_TRACKBAR3);
		m_nTrackbar3 = pSlide3->GetPos();
		CSliderCtrl* pSlide4 =(CSliderCtrl*) GetDlgItem(IDC_TRACKBAR4);
		m_nTrackbar4 = pSlide4->GetPos();
		CSliderCtrl* pSlide5 =(CSliderCtrl*) GetDlgItem(IDC_TRACKBAR5);
		m_nTrackbar5 = pSlide5->GetPos();
		CSliderCtrl* pSlide6 =(CSliderCtrl*) GetDlgItem(IDC_TRACKBAR6);
		m_nTrackbar6 = pSlide6->GetPos();
		CSliderCtrl* pSlide7 =(CSliderCtrl*) GetDlgItem(IDC_TRACKBAR7);
		m_nTrackbar7 = pSlide7->GetPos();
		CSliderCtrl* pSlide8 =(CSliderCtrl*) GetDlgItem(IDC_TRACKBAR8);
		m_nTrackbar8 = pSlide8->GetPos();
		CSliderCtrl* pSlide9 =(CSliderCtrl*) GetDlgItem(IDC_TRACKBAR9);
		m_nTrackbar9 = pSlide9->GetPos();
		CSliderCtrl* pSlide10 =(CSliderCtrl*) GetDlgItem(IDC_TRACKBAR10);
		m_nTrackbar10 = pSlide10->GetPos();
	}
}


BEGIN_MESSAGE_MAP(CJuliaFractalDialog, CDialog)
	//{{AFX_MSG_MAP(CJuliaFractalDialog)
	ON_WM_VSCROLL()
	ON_WM_HSCROLL()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CJuliaFractalDialog message handlers

BOOL CJuliaFractalDialog::OnInitDialog() 
{
		
	
	CSpinButtonCtrl* pSpin1=(CSpinButtonCtrl*)GetDlgItem(IDC_SPIN1);
	pSpin1->SetRange(0,4000);
	pSpin1->SetPos(((int)(Cx*1000))+2000);//Posicin inicial 
	CSpinButtonCtrl* pSpin2=(CSpinButtonCtrl*)GetDlgItem(IDC_SPIN2);
	pSpin2->SetRange(0,4000);
	pSpin2->SetPos(((int)(Cy*1000))+2000);
	CSpinButtonCtrl* pSpin3=(CSpinButtonCtrl*)GetDlgItem(IDC_SPIN3);
	pSpin3->SetRange(0,2000);
	pSpin3->SetPos(1000);
	
	CString strText1;
	CSliderCtrl* pSlide1=(CSliderCtrl*)GetDlgItem(IDC_TRACKBAR1);
	pSlide1->SetRange(0,255);
	pSlide1->SetPos(m_nTrackbar1);
	strText1.Format("%d",pSlide1->GetPos());
	SetDlgItemText(IDC_STATIC_TRACK1,strText1);

	CString strText2;
	CSliderCtrl* pSlide2=(CSliderCtrl*)GetDlgItem(IDC_TRACKBAR2);
	pSlide2->SetRange(0,255);
	pSlide2->SetPos(m_nTrackbar2);
	strText2.Format("%d",pSlide2->GetPos());
	SetDlgItemText(IDC_STATIC_TRACK2,strText2);

	CString strText3;
	CSliderCtrl* pSlide3=(CSliderCtrl*)GetDlgItem(IDC_TRACKBAR3);
	pSlide3->SetRange(0,255);
	pSlide3->SetPos(m_nTrackbar3);
	strText3.Format("%d",pSlide3->GetPos());
	SetDlgItemText(IDC_STATIC_TRACK3,strText3);

	CString strText4;
	CSliderCtrl* pSlide4=(CSliderCtrl*)GetDlgItem(IDC_TRACKBAR4);
	pSlide4->SetRange(0,255);
	pSlide4->SetPos(m_nTrackbar4);
	strText4.Format("%d",pSlide4->GetPos());
	SetDlgItemText(IDC_STATIC_TRACK4,strText4);

	CString strText5;
	CSliderCtrl* pSlide5=(CSliderCtrl*)GetDlgItem(IDC_TRACKBAR5);
	pSlide5->SetRange(0,255);
	pSlide5->SetPos(m_nTrackbar5);
	strText5.Format("%d",pSlide5->GetPos());
	SetDlgItemText(IDC_STATIC_TRACK5,strText5);

	CString strText6;
	CSliderCtrl* pSlide6=(CSliderCtrl*)GetDlgItem(IDC_TRACKBAR6);
	pSlide6->SetRange(0,255);
	pSlide6->SetPos(m_nTrackbar6);
	strText6.Format("%d",pSlide6->GetPos());
	SetDlgItemText(IDC_STATIC_TRACK6,strText6);

	CString strText7;
	CSliderCtrl* pSlide7=(CSliderCtrl*)GetDlgItem(IDC_TRACKBAR7);
	pSlide7->SetRange(0,255);
	pSlide7->SetPos(m_nTrackbar7);
	strText7.Format("%d",pSlide7->GetPos());
	SetDlgItemText(IDC_STATIC_TRACK7,strText7);

	CString strText8;
	CSliderCtrl* pSlide8=(CSliderCtrl*)GetDlgItem(IDC_TRACKBAR8);
	pSlide8->SetRange(0,255);
	pSlide8->SetPos(m_nTrackbar8);
	strText8.Format("%d",pSlide8->GetPos());
	SetDlgItemText(IDC_STATIC_TRACK8,strText8);

	CString strText9;
	CSliderCtrl* pSlide9=(CSliderCtrl*)GetDlgItem(IDC_TRACKBAR9);
	pSlide9->SetRange(0,255);
	pSlide9->SetPos(m_nTrackbar9);
	strText9.Format("%d",pSlide9->GetPos());
	SetDlgItemText(IDC_STATIC_TRACK9,strText9);

	CString strText10;
	CSliderCtrl* pSlide10=(CSliderCtrl*)GetDlgItem(IDC_TRACKBAR10);
	pSlide10->SetRange(0,255);
	pSlide10->SetPos(m_nTrackbar10);
	strText10.Format("%d",pSlide10->GetPos());
	SetDlgItemText(IDC_STATIC_TRACK10,strText10);

	return CDialog::OnInitDialog();
	
}



void CJuliaFractalDialog::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	// TODO: Add your message handler code here and/or call default
	
	//CDialog::OnVScroll(nSBCode, nPos, pScrollBar);

	if (nSBCode==SB_ENDSCROLL)
		return;	//Rechaza mensajes espreos
	if (pScrollBar->GetDlgCtrlID()==IDC_SPIN1){
		CString strValue;
		strValue.Format("%4.3f",(float) (nPos-2000.0)/1000.0);
		((CSpinButtonCtrl*)pScrollBar)->GetBuddy()->SetWindowText(strValue);
	}
	if (pScrollBar->GetDlgCtrlID()==IDC_SPIN2){
		CString strValue;
		strValue.Format("%4.3f",(float) (nPos-2000.0)/1000.0);
		((CSpinButtonCtrl*)pScrollBar)->GetBuddy()->SetWindowText(strValue);
	}
	if (pScrollBar->GetDlgCtrlID()==IDC_SPIN3){
		CString strValue;
		strValue.Format("%4.3f",(float) nPos/1000.0);
		((CSpinButtonCtrl*)pScrollBar)->GetBuddy()->SetWindowText(strValue);
	}

	//Lo que ves es lo que recibes
}


void CJuliaFractalDialog::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	// TODO: Add your message handler code here and/or call default
	
	//CDialog::OnHScroll(nSBCode, nPos, pScrollBar);

	CSliderCtrl* pSlide=(CSliderCtrl*)pScrollBar;
	CString strText;
	//Seis barras de siguimiento estn enviando mensajes
	//HSCROLL debe diferenciarlas
	switch (pScrollBar->GetDlgCtrlID()){
	case IDC_TRACKBAR1:
		strText.Format("%d",pSlide->GetPos());
		SetDlgItemText(IDC_STATIC_TRACK1,strText);
		break;
	case IDC_TRACKBAR2:
		strText.Format("%d",pSlide->GetPos());
		SetDlgItemText(IDC_STATIC_TRACK2,strText);
		break;
	case IDC_TRACKBAR3:
		strText.Format("%d",pSlide->GetPos());
		SetDlgItemText(IDC_STATIC_TRACK3,strText);
		break;
	case IDC_TRACKBAR4:
		strText.Format("%d",pSlide->GetPos());
		SetDlgItemText(IDC_STATIC_TRACK4,strText);
		break;
	case IDC_TRACKBAR5:
		strText.Format("%d",pSlide->GetPos());
		SetDlgItemText(IDC_STATIC_TRACK5,strText);
		break;
	case IDC_TRACKBAR6:
		strText.Format("%d",pSlide->GetPos());
		SetDlgItemText(IDC_STATIC_TRACK6,strText);
		break;
	case IDC_TRACKBAR7:
		strText.Format("%d",pSlide->GetPos());
		SetDlgItemText(IDC_STATIC_TRACK7,strText);
		break;
	case IDC_TRACKBAR8:
		strText.Format("%d",pSlide->GetPos());
		SetDlgItemText(IDC_STATIC_TRACK8,strText);
		break;
	case IDC_TRACKBAR9:
		strText.Format("%d",pSlide->GetPos());
		SetDlgItemText(IDC_STATIC_TRACK9,strText);
		break;
	case IDC_TRACKBAR10:
		strText.Format("%d",pSlide->GetPos());
		SetDlgItemText(IDC_STATIC_TRACK10,strText);
		break;
		
	}
}
